#lang racket/base

(module+ test
  (require rackunit)
  ;; Tests to be run with raco test
  )

(module+ main
  (require
    "src/webcontainer/webcontainer.rkt"
    "src/webcontainer/website.rkt"
    "src/pages/sitemap.rkt"
    "src/pages/floraverse.rkt")
  ; Website
  (define *website*
    (website
      "" weblet pages:floraverse-character-generator
      ("Tweet" weblet pages:floraverse-character-generator-tweet)
      ("Calendar" weblet pages:floraverse-calendar)
      ("Calendar/{month}/{day}" matching-weblet pages:floraverse-calendar)
      ("About" weblet pages:floraverse-about)
      ))
  ; Sitemap
  (sitemap
    '(("Character Generator" "/" #t)
      ("Calendar" "/Calendar" #f)
      ("About" "/About" #f))
    )
  ; Webcontainer
  (define *webcontainer*
    (make-webcontainer
      #:port 8181
      #:static
        (make-immutable-hash
          `(("" . "./static")))))
  (webcontainer-add-website! *webcontainer* *website*)
  (webcontainer-set-404-weblet! *webcontainer* pages:not-found)
  (display "Starting server...")(newline)
  (webcontainer-start *webcontainer*))
